/*
Copyright 2010 James Pether Sörling Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. 
	$Id
*/

package com.hack23.cia.functionalintegrationtest.scenarios.service.admin;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.test.context.transaction.AfterTransaction;
import org.springframework.test.context.transaction.BeforeTransaction;

import com.hack23.cia.service.dao.AgencyDAO;
import com.hack23.cia.service.dao.BallotDAO;
import com.hack23.cia.service.impl.admin.LoaderService;
import com.hack23.cia.service.impl.common.ParliamentService;
import com.hack23.cia.testfoundation.AbstractFunctionalIntegrationTransactionalTest;

/**
 * The Class LoaderServiceImplGenerateChartsSuccessFullTest.
 */
public class LoaderServiceImplGenerateChartsSuccessFullTest extends
        AbstractFunctionalIntegrationTransactionalTest {

    /** The agency dao. */
    @Autowired
    @Qualifier("agencyDAO")
    private AgencyDAO agencyDAO;

    /** The ballot dao. */
    @Autowired
    @Qualifier("ballotDAO")
    private BallotDAO ballotDAO;
    
    /** The loader service. */
    @Autowired
    @Qualifier("loaderService")
    private LoaderService loaderService;
    
    /** The parliament service. */
    @Autowired
    @Qualifier("parliamentService")
    private ParliamentService parliamentService;
    
    
    
    
    
    /**
     * Instantiates a new loader service impl generate charts success full test.
     */
    public LoaderServiceImplGenerateChartsSuccessFullTest() {
        super();
        this.testScenarioName = this.getClass().getSimpleName();
    }

    /**
     * Generate charts succeeds.
     *
     * @throws Exception the exception
     */
    @Test
    public final void generateChartsSucceeds() throws Exception {
    	//    	loaderService.generateCommitteeReportCharts();
    	//    	loaderService.generateBallotCharts();
    }

    /**
     * Setup database pre condition.
     *
     * @throws Exception the exception
     */
    @BeforeTransaction
    public void setupDatabasePreCondition() throws Exception {
    	this.cleanOutOldTestData();
    }

    /**
     * Verify database post condition.
     *
     * @throws Exception the exception
     */
    @AfterTransaction
    public void verifyDatabasePostCondition() throws Exception {
//    	Agency agency = agencyDAO.load(1L);
//    	for (Language language : agency.getLanguages()) {
  //    		
//    		
//    		for (CommitteeReport committeeReport : parliamentService.getAllCommiteeReports()) {
//    			Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.Summary,committeeReport,language));        		
//        		Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.Outcome,committeeReport,language));
//        		Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.ProffessionalBehavior,committeeReport,language));
//        		Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.PoliticalPartyBehavior,committeeReport,language));    			
//    		}
//    		
//    		for (Ballot ballot : ballotDAO.getAll()) {
//    			Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.Summary,ballot,language));        		
//        		Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.Outcome,ballot,language));
//        		Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.ProffessionalBehavior,ballot,language));
//        		Assert.assertNotNull("Chart Missing:",parliamentService.getGraph(ParliamentChart.PoliticalPartyBehavior,ballot,language));    			    			
//    		}
//    		
//    	}
    }
}
