/*
Copyright 2010 James Pether Sörling Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. 
	$Id
*/
package com.hack23.cia.functionalintegrationtest.scenarios.web.controller.common;

import com.hack23.cia.web.controller.common.UserStateService;

/**
 * The Class FakeUserStateService.
 */
public class FakeUserStateService implements UserStateService {

    /** The user session id. */
    private Long userSessionId;

    /*
     * (non-Javadoc)
     * 
     * @see
     * com.hack23.cia.web.controller.common.UserStateService#getUserSessionId()
     */
    @Override
    public synchronized Long getUserSessionId() {
        return userSessionId;
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * com.hack23.cia.web.controller.common.UserStateService#setUserSessionId
     * (java.lang.Long)
     */
    @Override
    public synchronized void setUserSessionId(Long userSessionId) {
        this.userSessionId = userSessionId;
    }
}
